# _*_ coding: utf8 _*_
import time # В этом модуле - задержки
import smbus # В этом модуле - средства для работы с шиной i2c

bus = smbus.SMBus(1) # Создаем объект "шина"
addrDM = 0x15 # Адрес цифрового модуля

buf = [0]*16  # Буфер для приема байтов от цифрового модуля
cntr = 0      # Счетчик успешный измерений
colls = 0     # Счетчик коллизий

while True:
  tries = 100 # Максимальное количество попыток доступа к данным модуля
  while tries > 0: 
    try: # Попытаемся получить данные
      bus.write_byte(addrDM, 0x00) # Сбрасываем индекс байтов в буфере модуля
      for i in range(16): # Считываем байты буфера последовательно
        buf[i] = bus.read_byte(addrDM)
      break
    except IOError:   # Устройство еще не готово - подождем 0.1 сек
      time.sleep(0.1) # и опять попробуем
      tries -= 1
      colls += 1      # Модифицируем счетчик коллизий
  if tries <= 0: # Что-то серьезно не так...
    print 'Цифровой модуль не доступен по i2c. Завершение работы.'
    sys.exit(1)
    
  cntr += 1 # Успешное чтение всех данных; модифицируем счетчик
  s = '% 6d ' % (cntr) # Начинаем формировать строку выдачи
  for i in range(8):
    w = buf[2*i]*256 + buf[2*i + 1] # Формируем слов из пары байтов
    if w <= 2000 and w > 0:
      s += '% 7.3f ' % (0.0625*w)
    elif w > 2000: s += '      1 '
    else: s += '      0 '
  s += '\x1b[32m% 6d\x1b[0m' % (colls)
  print s
  time.sleep(1)
